TFTP automatic boot file download does not track updates
Description

My colleague and I ran into a bug in the Ubuntu 12.04.4 netboot kernel.  A fix is available in a newer version, but the Smart-proxy

does not check for changes in the boot files if they already exist in the tftp directory.

A workaround for most systems is to delete the local files from the TFTP directory before a build, allowing the Smart-proxy to

download the new files.  On Debian-based systems this does not work, though.  The problem there is that

Operatingsystem::Debian#boot_files_uri builds the download URI based on the release name, but most distros place fixes and

updates in codename-updates and/or codename-security.  Changing the release name to something like codename-updates causes

other URIs to fail, so the workaround for Debian-based operating systems is to delete the local files and replace them with current

files by hand.

Due to a lack of reliable metadata, staying up-to-date is probably not entirely feasible.  The files could be downloaded at an interval,

like every 5th build or the first build of each week.  Cron scripts could also be generated, or just suggested in the documentation.

Debian systems might also be brought into parity with others via a custom URI option or some exception logic (once #3034 is

resolved).

Related issues:

Related to Foreman - Refactor #5121: Download kernel and image during OS crea... New 04/09/2014

Related to Foreman - Bug #12474: tftpboot files are not deleted when OS name ... New 11/13/2015

Related to Smart Proxy - Feature #3034: TFTP file download should be synchron... New

History

#1 - 04/04/2014 07:47 AM - Dominic Cleal

- Project changed from Foreman to Smart Proxy

- Category set to TFTP

#2 - 04/09/2014 11:05 AM - Dominic Cleal

- Related to Refactor #5121: Download kernel and image during OS creation rather than prior build added

#3 - 11/16/2015 02:58 AM - Dominic Cleal

- Related to Bug #12474: tftpboot files are not deleted when OS name is changed added

#4 - 12/30/2016 09:46 AM - Anonymous

- Related to Feature #3034: TFTP file download should be synchronous and handle errors added
